#include <konkret/konkret.h>
#include "LMI_EnabledAccountCapabilities.h"

#include "macros.h"
#include "globals.h"

#include <stdbool.h>

static const CMPIBroker* _cb = NULL;

static void LMI_EnabledAccountCapabilitiesInitialize()
{
}

static CMPIStatus LMI_EnabledAccountCapabilitiesCleanup(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesEnumInstanceNames(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesEnumInstances(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    LMI_EnabledAccountCapabilities leac;

    const char *nameSpace = KNameSpace(cop);

    LMI_EnabledAccountCapabilities_Init(&leac, _cb, nameSpace);
    LMI_EnabledAccountCapabilities_Set_InstanceID(&leac, ORGID":"LEACNAME);
    LMI_EnabledAccountCapabilities_Set_ElementName(&leac, LEACNAME);
    LMI_EnabledAccountCapabilities_Init_RequestedStatesSupported(&leac, 0);
    LMI_EnabledAccountCapabilities_Set_ElementNameEditSupported(&leac,
      false);

    KReturnInstance(cr, leac);

    CMReturn(CMPI_RC_OK);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesGetInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesCreateInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesModifyInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci,
    const char** properties)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesDeleteInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesExecQuery(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* lang,
    const char* query)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

CMInstanceMIStub(
    LMI_EnabledAccountCapabilities,
    LMI_EnabledAccountCapabilities,
    _cb,
    LMI_EnabledAccountCapabilitiesInitialize())

static CMPIStatus LMI_EnabledAccountCapabilitiesMethodCleanup(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus LMI_EnabledAccountCapabilitiesInvokeMethod(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* meth,
    const CMPIArgs* in,
    CMPIArgs* out)
{
    return LMI_EnabledAccountCapabilities_DispatchMethod(
        _cb, mi, cc, cr, cop, meth, in, out);
}

CMMethodMIStub(
    LMI_EnabledAccountCapabilities,
    LMI_EnabledAccountCapabilities,
    _cb,
    LMI_EnabledAccountCapabilitiesInitialize())

KUint16 LMI_EnabledAccountCapabilities_CreateGoalSettings(
    const CMPIBroker* cb,
    CMPIMethodMI* mi,
    const CMPIContext* context,
    const LMI_EnabledAccountCapabilitiesRef* self,
    const KStringA* TemplateGoalSettings,
    KStringA* SupportedGoalSettings,
    CMPIStatus* status)
{
    KUint16 result = KUINT16_INIT;

    KSetStatus(status, ERR_NOT_SUPPORTED);
    return result;
}

KONKRET_REGISTRATION(
    "root/cimv2",
    "LMI_EnabledAccountCapabilities",
    "LMI_EnabledAccountCapabilities",
    "instance method")
